



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>BZOJ2164 : 采矿</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">BZOJ2164 : 采矿</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-27 13:08:14 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>树链剖分+线段树，每个节点维护以下信息：</p>
<p>(1)单独在某个点分配$i$个人的最大收益。可以$O(m)$合并。</p>
<p>(2)分配$i$个人的最大收益。可以用$O(m^2)$合并。</p>
<p>时间复杂度$O(c(m^2\log n+m\log^2n))$。</p>
<div>
<pre class="prettyprint linenums">#include&lt;cstdio&gt;<br />
#include&lt;algorithm&gt;<br />
using namespace std;<br />
typedef long long ll;<br />
const int N=20010,M=51,T=65600;<br />
int n,m,q,X=1&lt;&lt;16,Y=~0U&gt;&gt;1,A,B,Q,i,op,x,y;<br />
int g[N],nxt[N],f[N],d[N],size[N],son[N],st[N],en[N],top[N],seq[N],dfn;<br />
struct P{<br />
  ll v[M];<br />
  P(){for(int i=0;i&lt;M;i++)v[i]=0;}<br />
  P operator+(P b){<br />
    P c;<br />
    for(int i=0;i&lt;M;i++)c.v[i]=max(v[i],b.v[i]);<br />
    return c;<br />
  }<br />
  P operator*(P b){<br />
    P c;<br />
    for(int i=0;i&lt;M;i++)for(int j=0;j&lt;M-i;j++)c.v[i+j]=max(c.v[i+j],v[i]+b.v[j]);<br />
    return c;<br />
  }<br />
}tmp,a[N],v0[T],v1[T],s0,s1;<br />
inline int getint(){<br />
  A=((A^B)+B/X+B*X)&amp;Y;<br />
  B=((A^B)+A/X+A*X)&amp;Y;<br />
  return(A^B)%Q;<br />
}<br />
inline void gettmp(){<br />
  for(int i=1;i&lt;=m;i++)tmp.v[i]=getint();<br />
  sort(tmp.v+1,tmp.v+m+1);<br />
}<br />
void dfs(int x){<br />
  size[x]=1;<br />
  for(int i=g[x];i;i=nxt[i]){<br />
    d[i]=d[x]+1,dfs(i),size[x]+=size[i];<br />
    if(size[i]&gt;size[son[x]])son[x]=i;<br />
  }<br />
}<br />
void dfs2(int x,int y){<br />
  seq[st[x]=++dfn]=x;top[x]=y;<br />
  if(son[x])dfs2(son[x],y);<br />
  for(int i=g[x];i;i=nxt[i])if(i!=son[x])dfs2(i,i);<br />
  en[x]=dfn;<br />
}<br />
inline void up(int x){<br />
  v0[x]=v0[x&lt;&lt;1]+v0[x&lt;&lt;1|1];<br />
  v1[x]=v1[x&lt;&lt;1]*v1[x&lt;&lt;1|1];<br />
}<br />
void build(int x,int a,int b){<br />
  if(a==b){v0[x]=v1[x]=::a[seq[a]];return;}<br />
  int mid=(a+b)&gt;&gt;1;<br />
  build(x&lt;&lt;1,a,mid),build(x&lt;&lt;1|1,mid+1,b),up(x);<br />
}<br />
void change(int x,int a,int b,int c){<br />
  if(a==b){v0[x]=v1[x]=tmp;return;}<br />
  int mid=(a+b)&gt;&gt;1;<br />
  if(c&lt;=mid)change(x&lt;&lt;1,a,mid,c);else change(x&lt;&lt;1|1,mid+1,b,c);<br />
  up(x);<br />
}<br />
void ask0(int x,int a,int b,int c,int d){<br />
  if(c&lt;=a&amp;&amp;b&lt;=d){s0=s0+v0[x];return;}<br />
  int mid=(a+b)&gt;&gt;1;<br />
  if(c&lt;=mid)ask0(x&lt;&lt;1,a,mid,c,d);<br />
  if(d&gt;mid)ask0(x&lt;&lt;1|1,mid+1,b,c,d);<br />
}<br />
void ask1(int x,int a,int b,int c,int d){<br />
  if(c&lt;=a&amp;&amp;b&lt;=d){s1=s1*v1[x];return;}<br />
  int mid=(a+b)&gt;&gt;1;<br />
  if(c&lt;=mid)ask1(x&lt;&lt;1,a,mid,c,d);<br />
  if(d&gt;mid)ask1(x&lt;&lt;1|1,mid+1,b,c,d);<br />
}<br />
inline void chain(int x,int y){<br />
  if(x==y)return;<br />
  x=f[x];<br />
  while(top[x]!=top[y])ask0(1,1,n,st[top[x]],st[x]),x=f[top[x]];<br />
  ask0(1,1,n,st[y],st[x]);<br />
}<br />
int main(){<br />
  scanf("%d%d%d%d%d",&amp;n,&amp;m,&amp;A,&amp;B,&amp;Q);<br />
  for(i=2;i&lt;=n;i++)scanf("%d",&amp;f[i]),nxt[i]=g[f[i]],g[f[i]]=i;<br />
  for(i=1;i&lt;=n;i++)gettmp(),a[i]=tmp;<br />
  dfs(1),dfs2(1,1),build(1,1,n);<br />
  scanf("%d",&amp;q);<br />
  while(q--){<br />
    scanf("%d%d",&amp;op,&amp;x);<br />
    if(!op)gettmp(),change(1,1,n,st[x]);<br />
    else{<br />
      scanf("%d",&amp;y);<br />
      s0=s1=P();<br />
      chain(x,y),ask1(1,1,n,st[x],en[x]);<br />
      s0=s0*s1;<br />
      printf("%lld\n",s0.v[m]);<br />
    }<br />
  }<br />
  return 0;<br />
}
</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kpp669.html">项目vue2&period;0仿外卖APP（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q252dlq.html">基础才是重中之重~Emit动态构建方法&lpar;参数和返回值）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jmkee9.html">配置javac环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/49ggxr09.html">JS中this的指向问题&amp;amp&semi;使用call或apply模拟new</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2o7zv9.html">Javascript输出表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnm61oq.html">c&num;danliemosih</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xnm4g9.html">NSS&lowbar;04 extjs中grid接收datetime类型参数列</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn57kd8.html">&lbrack;HDOJ3974&rsqb;Assign the task（建树胡搞）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90voleo8.html">libcurl提交表单上传文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv150eyq.html">js 几个特殊情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpvder9.html">SpringMVC &plus; spring3&period;1&period;1 &plus; hibernate4&period;1&period;0 集成及常见问题总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z6p109.html">在centos7中手动编译greenplum</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj2x0x9.html">做一个合格的Team Leader -- 基本概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rrle58.html">Javascript高级编程学习笔记（67）&mdash;&mdash; 事件（11）HTML5事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwpp3z8.html">NDK中使用pthread多线程中自己写的一个BUG</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rj3zn9.html">开源RPC Jupiter</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25g1nxq.html">wmv 播放器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv07p28.html">自学工业控制网络之路1&period;2-典型的现场总线介绍PROFIBUS</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5225mq.html">python中的IO模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5xkw4q.html">Ubuntu关闭进入screensaver模式</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/oqvp1yzq.html">CentOS出错You don&amp;&num;39&semi;t have permission to access on this server</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqd1wpzq.html">早上3：30左右起来发现时候电脑在一致叫唤就是一个usb的接口可能是鼠标</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k6o27q.html">JAVA基础学习之final关键字、遍历集合、日期类对象的使用、Math类对象的使用、Runtime类对象的使用、时间对象Date（两个日期相减）（5）</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn623j9.html">Java Hour 67 Java Collection API</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn654k9.html">WCF学习笔记之WCF初识</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rp0er8.html">静态内容生成器&amp;mdash&semi;&amp;mdash&semi;Wyam</a>
			</li>
						<li><a href="https://www.batexi.com/a/3900eon9.html">Windows和Windows Phone应用终于可以使用FFmpeg了</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8opgjeq.html">C语言中main函数的参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zp4e19.html">Sublime Text3 配置Node&period;js运行命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zp3yn9.html">直接拿来用！最火的Android开源项目（完结篇）（转）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
